<?php

namespace app\controllers\mikrotik\wireless;

use yii\helpers\Url;
use Yii;
use yii\filters\AccessControl;
use yii\web\Controller;
use yii\filters\VerbFilter;
use yii\data\ArrayDataProvider;
use app\models\mikrotik\MikrotikSideMenu;
use app\models\mikrotik\wireless\Interfaces;

class InterfacesController extends Controller {

    public function behaviors() {
        return [
            'access' => [
                'class' => AccessControl::className(),
                'except' => ['index'],
                'rules' => [
                    [
                        'actions' => ['create'],
                        'allow' => true,
                        'roles' => ['mikrotik_wirelessCreateInterfaces'],
                    ],
                    [
                        'actions' => ['delete'],
                        'allow' => true,
                        'roles' => ['mikrotik_wirelessDeleteInterfaces'],
                    ],
                    [
                        'actions' => ['disable'],
                        'allow' => true,
                        'roles' => ['mikrotik_wirelessDisableInterfaces'],
                    ],
                    [
                        'actions' => ['enable'],
                        'allow' => true,
                        'roles' => ['mikrotik_wirelessEnableInterfaces'],
                    ],
                    [
                        'actions' => ['update'],
                        'allow' => true,
                        'roles' => ['mikrotik_wirelessUpdateInterfaces'],
                    ],
                    [
                        'actions' => [],
                        'allow' => true,
                        'roles' => ['admin'],
                    ],
                ],
            ],
            'verbs' => [
                'class' => VerbFilter::className(),
                'actions' => [
                    'logout' => ['post'],
                ],
            ],
        ];
    }

    public function actions() {
        return [
            'error' => [
                'class' => 'yii\web\ErrorAction',
            ],
            'captcha' => [
                'class' => 'yii\captcha\CaptchaAction',
                'fixedVerifyCode' => YII_ENV_TEST ? 'testme' : null,
            ],
        ];
    }

    public function actionIndex() {
        $model = new Interfaces();
    }

    public function actionUpdate() {
        $id = Yii::$app->request->get('id');
        $menu = new MikrotikSideMenu();
        $model = new Interfaces();

        if ($model->load(Yii::$app->request->post()) && $model->validate()) {

            $c = $model->update($id);
            if ($c != '1') {
                Yii::$app->session->setFlash('message', $c);
            } else {
                return $this->redirect(Url::toRoute('mikrotik/wireless/wireless/index'));
            }
        } else {
            $model->get($id);
        }

        return $this->render('/mikrotik/wireless/interfaces', [
                    'menu' => $menu->getMenu(),
                    'model' => $model,
                    'action' => 'update',
                    'bridge' => $model->getBridgeNames(),
                    'masterIntreface' => $model->getNames(),
                    'items' => $model->getSecProf(),
        ]);
    }

    public function actionCreate() {

        $menu = new MikrotikSideMenu();
        $model = new Interfaces();
        $model->interface_type = 'virtual-AP';
        if ($model->load(Yii::$app->request->post()) && $model->validate()) {

            $c = $model->create();
            if ($c != '1') {
                Yii::$app->session->setFlash('message', $c);
            } else {
                return $this->redirect(Url::toRoute('mikrotik/wireless/wireless/index'));
            }
        }

        return $this->render('/mikrotik/wireless/interfaces', [
                    'menu' => $menu->getMenu(),
                    'model' => $model,
                    'action' => 'create',
                    'bridge' => $model->getBridgeNames(),
                    'masterIntreface' => $model->getNames(),
                    'items' => $model->getSecProf(),
        ]);
    }

    public function actionEnable() {
        $id = Yii::$app->request->get('id');
        $model = new Interfaces();
        $model->enable($id);
        return $this->redirect(Url::toRoute('mikrotik/wireless/wireless/index'));
    }

    public function actionDisable() {
        $id = Yii::$app->request->get('id');
        $model = new Interfaces();
        $model->disable($id);
        return $this->redirect(Url::toRoute('mikrotik/wireless/wireless/index'));
    }

    public function actionDelete() {
        $id = Yii::$app->request->get('id');
        $model = new Interfaces();
        $model->delete($id);
        return $this->redirect(Url::toRoute('mikrotik/wireless/wireless/index'));
    }

}
